﻿package {
	
	import Box2DAS.*;
	import Box2DAS.Collision.*;
	import Box2DAS.Collision.Shapes.*;
	import Box2DAS.Common.*;
	import Box2DAS.Dynamics.*;
	import Box2DAS.Dynamics.Contacts.*;
	import Box2DAS.Dynamics.Joints.*;
	import misc.*;
	import flash.events.*;
	import flash.utils.*;
	
	public class Contact extends Test {
		
		public var f:b2Fixture;
		public var b:b2Body;
		
		
		public function Contact() {
			super();
			
			Main.txt.text = "Contact";
			
			b2Def.body.type = b2Body.b2_dynamicBody;
			b2Def.body.position.x = 300 / scale;
			b2Def.body.position.y = 100 / scale;
			b2Def.body.allowSleep = false;
			b2Def.polygon.SetAsBox(50 / scale, 50 / scale);
			b2Def.fixture.shape = b2Def.polygon;
			b2Def.fixture.density = 1;
			b = b2Def.body.create(this);
			f = b2Def.fixture.create(b);
			f.m_userData = 'Fixture 1';
			f.m_reportBeginContact = true;
			f.m_reportEndContact = true;
			
			f.addEventListener(ContactEvent.BEGIN_CONTACT, reportContact);
			f.addEventListener(ContactEvent.END_CONTACT, reportContact);
			
			b2Def.body.type = b2Body.b2_staticBody;
			b2Def.body.position.x = 300 / scale;
			b2Def.body.position.y = 300 / scale;
			b = b2Def.body.create(this);
			f = b2Def.fixture.create(b);
			f.m_userData = 'Fixture 2';
			f.m_reportBeginContact = true;
			f.m_reportEndContact = true;
			
			f.addEventListener(ContactEvent.BEGIN_CONTACT, reportContact);
			f.addEventListener(ContactEvent.END_CONTACT, reportContact);
			
			setTimeout(removeBody, 2000);
		}
		
		public function removeBody():void {
			b.destroy();
		}
		
		public function reportContact(e:ContactEvent):void {
			trace('Contact Event', e.type, (e.target as b2Fixture).m_userData);
		}
	}
}