﻿package {
	
	import Box2DAS.*;
	import Box2DAS.Collision.*;
	import Box2DAS.Collision.Shapes.*;
	import Box2DAS.Common.*;
	import Box2DAS.Dynamics.*;
	import Box2DAS.Dynamics.Contacts.*;
	import Box2DAS.Dynamics.Joints.*;
	import flash.display.*;
	import flash.events.*;
	import flash.utils.*;
	import misc.*;
	
	public class Test extends b2World {
		
		public var scale:Number = 30;
		public var mj:b2MouseJoint = null;
		
		public function Test() {
			super(new V2(0, 10));
			b2Def.initialize();
			CreateWalls();
			Main.txt.text = "";
		}
		
		public function CreateWalls():void {
			with(b2Def.polygon) {
				var w:Number = 720;
				var h:Number = 480;
				var w2:Number = w / 2;
				var h2:Number = h / 2;
				var t:Number = 100;
				var i:Number = 95;
				SetAsBox(t / scale, h2 / scale, new V2(-i / scale, h2 / scale)); // left
				create(m_groundBody);
				SetAsBox(t / scale, h2 / scale, new V2((w + i) / scale, h2 / scale)); // right
				create(m_groundBody);
				SetAsBox(w2 / scale, t / scale, new V2(w2 / scale, -i / scale)); // top
				create(m_groundBody);
				SetAsBox(w2 / scale, t / scale, new V2(w2 / scale, (h + i) / scale)); // bottom
				create(m_groundBody);
			}
		}
		
		public function EnterFrame():void {
			UpdateMouse();
			/// 20 fps - cheap way to make things seem faster ;)
			Step(1 / 20, 8, 3);//10, 10);
		}
		
		public function UpdateMouse():void {
			var mp:V2 = new V2(Input.mousePos.x / scale, Input.mousePos.y / scale);
			var body:b2Body;
			if (Input.mouseIsDown && !mj && !Input.kd('D')) {
				body = GetBodyAtMouse(mp, false);
				if(body) {
					with(b2Def.mouseJoint) {
						bodyA = m_groundBody;
						bodyB = body;
						target.v2 = mp;
						collideConnected = true;
						maxForce = 300.0 * body.GetMass();
					}
					mj = CreateJoint(b2Def.mouseJoint) as b2MouseJoint;
					body.SetAwake(true);
				}
			}
			if ((!Input.mouseIsDown || Input.kd('D')) && mj) {
				DestroyJoint(mj);
				mj = null;
			}
			if (mj) {
				mj.SetTarget(mp);
			}
			if (Input.mouseIsDown && Input.kd('D')) {
				body = GetBodyAtMouse(mp, true);
				if (body) {
					DestroyBody(body);
				}
			}
		}

		public function GetBodyAtMouse(mp:V2, includeStatic:Boolean = false):b2Body {
			var body:b2Body = null;
			QueryPoint(function(f:b2Fixture):Boolean {
				var b:b2Body = f.GetBody();
				if(b.IsDynamic() || includeStatic) {
					body = b;
					return false;
				}
				return true;
			}, mp);
			return body;
		}
	}
	
}